

#include<stdio.h>
#include<unistd.h>
#include<sys/wait.h>
#include<netinet/in.h>
#include<string.h>
#include<stdlib.h>
#include<pthread.h>

#include"sitar.h"
#include"sitar_com.h"
#include<almemsys/almemsys.h>
#include"jpreturn.h"
#include<file_comp/file_comp.h>

extern global_data_t gd;
extern swap_array_t sa;

extern pthread_mutex_t file1_mutex;




// ポートスキャンとコマンド監視用のスレッド関数
int sitar_scan(void)
{
FILE * fp;
long int fdcount;
int stat, bstat, ren, count, delmi, fdclean, fdcountstat, sleepcount;
stat = 0;
bstat = 0;
ren = 0;
count = 0;
delmi = 1;


for(;;){

   #ifdef SCAN_BUG
   printf("SCAN_BUG: sitar_scan(): ループの開始またはループの先頭に戻りました fdcount<%ld>\n",
      fdcount);
   #endif

   // 一次リストファイルから二次リストファイルにコピー
   pthread_mutex_lock(&file1_mutex);
   gd.fi.bat2_filestat = stat_check(gd.fi.bat2_filestat, gd.fi.bat2_filename, IP_LEN, &bstat);
   if(0 > bstat){
      #ifdef SCAN_BUG
      printf("SCAN_BUG: sitar_scan(): 編集があったので一次ファイルから二次ファイルにコピーします fdcount<%ld>\n",
         fdcount);
      #endif
      file_copy(gd.fi.bat2_filename, gd.fi.bat2_filename_2);
      }
   pthread_mutex_unlock(&file1_mutex);


   if((fp = fopen(gd.fi.bat2_filename_2, "r+"))!=NULL){
      #ifdef SCAN_BUG
      printf("SCAN_BUG: sitar_scan(): 二次ファイルiを開きました。 fdcount<%ld>\n",
         fdcount);
      #endif
      while(1){
         gd.sd.swap = safe_fpcat(fp, gd.sd.swap, &stat, BUF_MAX);
         delmi = memcmp(gd.sd.swap, "*****", 5);

         if(ren <= (gd.td.tbufmax - 1)){
            if(stat == 0 && delmi != 0 && 0x00 != gd.sd.swap[0]){
               gd.sd.swap = check_strtol(gd.sd.swap);
               if('#' != gd.sd.swap[0]){
                  sa.tmp_data[ren] = safe_memcpy(sa.tmp_data[ren], gd.sd.swap, BUF_MAX);
                  #ifdef FREE_BUG
                  printf("FREE: single sitar_scan(1): gd.sd.swap %s\n", gd.sd.swap);
                  #endif
                  free(gd.sd.swap);
                  gd.sd.swap = NULL;
                  gd.sd.swap = (char *)calloc(IP_LEN, sizeof(char));
                  ren++;
                  }
               else{
                  #ifdef FREE_BUG
                  printf("FREE: single sitar_scan(2): gd.sd.swap %s\n", gd.sd.swap);
                  #endif
                  free(gd.sd.swap);
                  gd.sd.swap = NULL;
                  gd.sd.swap = (char *)calloc(IP_LEN, sizeof(char));
                  }
               }
            }
         else{
            sa.main_buf_err = 1;
            fprintf(stderr ,"sitar_scan(): バッファの上限値を越えています。 <%d> : gd.td.tbufmax<%d>\n",
              ren, gd.td.tbufmax);
            }

         /*  ---- **** Block ------ */
         if(ren < gd.td.tbufmax && stat == 0 && delmi == 0){

            for(fdcountstat = 0;fdcountstat == 0;){
               for(fdcount = 0; fdcount < gd.td.tcount; fdcount++){
                  #ifdef SCAN_BUG
                  printf("SCAN_BUG: sitar_scan(***block): fdcount<%ld>fdstat<%d>\n",
                    fdcount, gd.td.fdstat[fdcount]);
                  #endif
                  if(gd.td.fdstat[fdcount] != 1){
                     gd.td.fdstat[fdcount] = 1;
                     #ifdef FREE_BUG
                     printf("FREE: sitar_scan(***block): safree(%ld) fdcount\n", fdcount);
                     #endif
                     safree(fdcount);
                     sacalloc(fdcount);
                     break;
                     }
                  }

               if(fdcount < gd.td.tcount){
                  for(count = 0; count < ren; count++){
                     sa.swap_data[fdcount][count] = safe_memcpy(
                         sa.swap_data[fdcount][count], sa.tmp_data[count], BUF_MAX); 
                     #ifdef SCAN_BUG
                     printf("SCAN_BUG: sitar_scan(***block): Thread No = %ld\n", fdcount);
                     #endif
                     }

                  if(sa.main_buf_err == 1){
                     sa.buf_err[fdcount] = 1;
                     sa.main_buf_err = 0;
                     }
                  else{
                     sa.buf_err[fdcount] = 0;
                     }
               // pthread_create
                  #ifdef SCAN_BUG
                  printf("SCAN_BUG: sitar_scan(***block): あたらしいスレッド Thread No = %ld\n", fdcount);
                  #endif
                  fdcountstat = 1;
                  pthread_create(&sa.pt[fdcount], NULL, (void *)scan_block, (int *)fdcount);
                  }
               else{
                  fprintf(stderr,"sitar_scan(****block): スレッドが作れませんでした (1). %ld\n", fdcount);
                  fdcountstat = 0;
                  fprintf(stderr,"sitar_scan(***block): 5秒待ってみます。 (5sec)(1). %ld\n", fdcount);
                  for(sleepcount = 0; sleepcount < 5; sleepcount++){
                     sleep(1);
                     }
                  }
               } // for()

            gd.sd.scan_all = safe_memcpy(gd.sd.scan_all, "\0", BUF_MAX);
            ren = 0;
            count = 0;
            } // if()

         /* ---- END Block ---- */
         if(ren >= gd.td.tbufmax || stat != 0){

            for(fdcountstat = 0;fdcountstat == 0;){
               for(fdcount = 0; fdcount < gd.td.tcount; fdcount++){
                  #ifdef SCAN_BUG
                  printf("SCAN_BUG: sitar_scan(END block 1): fdcount<%ld>fdstat<%d>\n",
                  fdcount, gd.td.fdstat[fdcount]);
                  #endif
                  if(gd.td.fdstat[fdcount] != 1){
                     gd.td.fdstat[fdcount] = 1;
                     #ifdef FREE_BUG
                     printf("FREE: sitar_scan(END block 2): safree(%ld) fdcount\n", fdcount);
                     #endif
                     safree(fdcount);
                     sacalloc(fdcount);
                     break;
                     }
                  }

               if(fdcount < gd.td.tcount){
                  for(count = 0; count < ren; count++){
                     sa.swap_data[fdcount][count] = safe_memcpy(
                         sa.swap_data[fdcount][count], sa.tmp_data[count], BUF_MAX); 
                     #ifdef SCAN_BUG
                     printf("SCAN_BUG: sitar_scan(END block 3): Thread No = %ld\n", fdcount);
                     #endif
                     }

                  ren = 0;
                  count = 0;

                  if(sa.main_buf_err == 1){
                     sa.buf_err[fdcount] = 1;
                     sa.main_buf_err = 0;
                     }
                  else{
                     sa.buf_err[fdcount] = 0;
                     }
               // pthread_create
                  fdcountstat = 1;
                  #ifdef SCAN_BUG
                  printf("SCAN_BUG: sitar_scan(END block): あたらしいスレッド Thread No = %ld\n", fdcount);
                  #endif
                  pthread_create(&sa.pt[fdcount], NULL, (void *)scan_block, (int *)fdcount);
                  }
               else {
                  fprintf(stderr,"sitar_scan(END block): スレッドが作れませんでした (2). %ld\n", fdcount);
                  fdcountstat = 0;
                  fprintf(stderr,"sitar_scan(END block): 5秒待ってみます。 (5sec)(2). %ld\n", fdcount);
                  for(sleepcount = 0; sleepcount < 5; sleepcount++){
                     sleep(1);
                     }
                  }
               }

            gd.sd.scan_all = safe_memcpy(gd.sd.scan_all, "\0", BUF_MAX);
            ren = 0;
            count = 0;
            #ifdef FILE_DEBUG
            printf("FILE: sitar_scan(): ファイルの終端、または読み込めませんでした\n");
            #endif
            break;
            } // if()

         } // while()


      stat = 0;
      #ifdef SCAN_BUG
      printf("SCAN_BUG: sitar_scan(): 二次ファイルを閉じました。 fdcount<%ld>\n",
         fdcount);
      #endif
      fclose( fp );
      } // fopen()


   #ifdef SCAN_BUG
   printf("SCAN_BUG: sitar_scan(): 次のバッファを開放します。 satmpfree satmpcalloc()\n");
   #endif 
   satmpfree();
   satmpcalloc();

   for(fdclean = 0; fdclean < gd.td.tcount; fdclean++){
      if(gd.td.fdstat[fdclean] != 1){
         #ifdef MALLOC_BUG
         printf("MALLOC: sitar_scan(): No used buffer cleanup. fdclean<%d>fdstat<%d>\n",
           fdclean, gd.td.fdstat[fdclean]);
         #endif
         #ifdef FREE_BUG
         printf("FREE: sitar_scan(): safree(%d) fdclean\n", fdclean);
         #endif
         safree(fdclean);
         sacalloc(fdclean);
         }
      }

   #ifdef SCAN_BUG
   printf("SCAN_BUG: sitar_scan(): ループから抜けます。 fdcount<%ld>fdstat<%d>utime<%ld>\n",
      fdcount, gd.td.fdstat[fdcount], (long int)time(NULL));
   #endif

   sleep(gd.bf.bat2_int);

   #ifdef SCAN_BUG
   printf("SCAN_BUG: sitar_scan():  スリープから抜けました。 fdcount<%ld>fdstat<%d>utime<%ld>\n",
      fdcount, gd.td.fdstat[fdcount], (long int)time(NULL));
   #endif

   } // for(;;)

// Not reachablle (ここに到達することはありません)

return 0;
}









